package DX::Op::ProposeAction;

use DX::ObservationRequired;
use Moo;

with 'DX::Role::Op';

has vars => (is => 'ro', required => 1);
has builder => (is => 'ro', required => 1);

has _arg_map => (is => 'lazy', builder => sub {
  my ($self) = @_;
  my $name = 'arg0';
  +{ map +($name++, $_), @{$self->vars} };
});

sub run {
  my ($self, $state) = @_;
  ($state, my %args) = $self->_expand_args($state, %{$self->_arg_map});
  my @vars = @args{sort keys %args};
  my @deps = $state->action_dependencies(map $_->id, @vars);
  my $action = $self->builder->(map $state->resolve_value($_), @vars)
                    ->but(dependencies => \@deps);
  my ($rec_state, $action_id) = $state->record_action($action);
  my ($fact_type, $value) = $action->expected_effect;
  my $final_value = $value->but(required_action => $action_id);
  my $fact_set = $state->facts->{$fact_type}->with_value($final_value);
  $rec_state->but(facts => { %{$state->facts}, $fact_type => $fact_set })
            ->then($self->next);
}

1;
